"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ASNIX923Padding = void 0;
class ASNIX923Padding {
    addPadding(data, blockSize) {
        const paddingLength = blockSize - data.length % blockSize;
        return new Uint8Array([...data, ...new Array(paddingLength - 1).fill(0), paddingLength]);
    }
    removePadding(data) {
        const paddingLength = data[data.length - 1];
        return data.slice(0, data.length - paddingLength);
    }
}
exports.ASNIX923Padding = ASNIX923Padding;
